/*
 * A0B36PRI_091123_08  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 08 - Soubory - zaklady
 *
 * Soubory - Zapis/cteni objektu
 * 
 */

package a0b36pri_091123_08;
import java.io.*;

public class X09k {

  public static void main(String[] args)//-------------------------------------
                     throws IOException,ClassNotFoundException {

    //=(1)======= write/read (pro objekty) ====================================
    System.out.println("==Zapis/cteni typu Object==");
    System.out.println("==(1)==== zapis/cteni typu Osoba  ========");
    // ==> Zalozeni nekolika objektu typu Osoba
    Osoba o1 = new Osoba("Novak","1234",30,5000);
    Osoba o2 = new Osoba("Dvorak", "4567", 45, 6000);
    Osoba o3 = new Osoba("Horak", "9999", 50, 8000);

    // ==> Zalozeni zastupne promenne typu File
    File f1 = new File("Osoby1.xxx");
    // ==>Zalozeni a Otevreni souboru pro ZAPIS
    //    Pokud jiz soubor existuje, jeho data se ztrati
    FileOutputStream fos1 = new FileOutputStream(f1);
    ObjectOutputStream oos1 = new ObjectOutputStream(fos1);
    // ==>Zapis do souboru (sekvencni / postupny)
    System.out.println("========= zapis objektu typu osoba =======");
    System.out.println("..........................................");
    oos1.writeObject(o1);
    oos1.writeObject(o2);
    oos1.writeObject(o3);
    // ==>Uzavreni souboru
    oos1.close();

    // ==> Zruseni puvodnich objektu (sesbira Garbage Collector)
    o1 = o2 = o3 = null;
    //Pozdeji test, obnoveni promennych tridy->NEobnovuji se
    Osoba.pocetObjektu = 0;
    Osoba[] osoby = new Osoba[5];

    // ==>Otevreni souboru pro CTENI
    FileInputStream fis1 = new FileInputStream(f1);
    ObjectInputStream ois1 = new ObjectInputStream(fis1);

    System.out.println("========= cteni objektu typu Osoba ========");
    // ==>Cteni ze souboru (sekvencni /postupny)
    //    Predpoklad:
    //       - typ objektu v souboru je znamy (zde Osoba)
    //       - pocet objektu v souboru neznamy (cteni zastavi vyjimka)
    try {
      for (int i = 0; i < osoby.length; i++) {
        osoby[i] = (Osoba)ois1.readObject();
        // Test->POZOR promenne tridy se ze souboru neobnovuji
        Osoba.pocetObjektu = i + 1;
      } // for() END
    }
    catch (EOFException e) {
      // EOF - stop reading
    }
    finally {
      // ==>Uzavreni souboru
      ois1.close();
      // ==>Zruseni souboru (musi byt uzavren)
      if(f1.delete()){
        System.out.println("Soubor: "+f1+" :zrusen");
      }
    } // try/catch/finally END

    // Tisk osob nactenych ze souboru
    for (int i = 0; osoby[i] != null; i++) {
      System.out.println(osoby[i].getJmeno() + " : " + osoby[i].getTelefon() + " : " +
              osoby[i].getVek() + " : " + osoby[i].getPlat() + " : " +
              " Pocet osob="+Osoba.pocetObjektu);
    } // for() END
    System.out.println("==(1)==== zapis/cteni typu Osoba END ========\n");
    //=(1)======= write/read (pro objekty) END ================================

    //=(2)======= write/read (pro objekty) ====================================
    System.out.println("==(2)==== zapis/cteni typu Osoba  ========");
    // ==> Zalozeni nekolika objektu typu Osoba
    int pocet=7;
    Integer pocetObjektu=new Integer(pocet);
    Osoba[] seznamOsob=new Osoba[pocet];
    seznamOsob[0]=new Osoba("Jan",  "1111",22,2000);
    seznamOsob[1]=new Osoba("Karel","2222",32,3000);
    // 3. prvek pole je umyslne ponechany null
    seznamOsob[3]=new Osoba("Petr", "3333",42,4000);
    seznamOsob[4]=new Osoba("Pavel","4444",52,5000);
    seznamOsob[5]=new Osoba("Jiri", "5555",62,6000);
    // 7. prvek pole je umyslne ponechany null

    // ==> Zalozeni zastupne promenne typu File
    File f2 = new File("Osoby2.xxx");
    // ==>Zalozeni a Otevreni souboru pro ZAPIS
    //    Pokud jiz soubor existuje, jeho data se ztrati
    FileOutputStream fos2 = new FileOutputStream(f2);
    ObjectOutputStream oos2 = new ObjectOutputStream(fos2);
    // ==>Zapis do souboru (sekvencni / postupny)
    System.out.println("========= zapis objektu typu osoba =======");
    System.out.println("..........................................");
    oos2.writeObject(pocetObjektu);
    for(int i=0;i<pocetObjektu.intValue();i++){
      oos2.writeObject(seznamOsob[i]);
    }// for() END
    // ==>Uzavreni souboru
    oos2.close();

    System.out.println("========= cteni objektu typu Osoba ========");
    // ==>Cteni ze souboru (sekvencni /postupny)
    //    Predpoklad:
    //       - typ objektu v souboru je ZNAMY (zde Osoba)
    //       - pocet objektu v souboru je ULOZENY jako prvni objekt
    //         a jeho typ je ZNAMY (zde Integer)

    // ==>Otevreni souboru pro CTENI
    FileInputStream fis2 = new FileInputStream(f2);
    ObjectInputStream ois2 = new ObjectInputStream(fis2);
    // ==>Precteni poctu ulozenych objektu (udaj do souboru predem zapsan)
    int pocetUlozenychOsob=((Integer)ois2.readObject()).intValue();
    Osoba[] nactenySeznamOsob=new Osoba[pocetUlozenychOsob];
    // ==>Precteni vsech osob (z nichz nektere mohou byt null)
    for(int i=0;i<pocetUlozenychOsob;i++){
      nactenySeznamOsob[i]=(Osoba)ois2.readObject();
      // POZOR promenne tridy se ze souboru neobnovuji
    }// for() END
    // ==>Uzavreni souboru
    ois2.close();
    // ==>Zruseni souboru (musi byt uzavren)
    if(f2.delete()){
      System.out.println("Soubor: "+f2+" :zrusen");
    }

    // Tisk osob nactenych ze souboru
    for (int i=0;i<nactenySeznamOsob.length; i++) {
      if(nactenySeznamOsob[i] == null){
        pocetUlozenychOsob--;
        continue;
      }// if() END
      System.out.println(nactenySeznamOsob[i].getJmeno() + " : " +
              nactenySeznamOsob[i].getTelefon() + " : " +
              nactenySeznamOsob[i].getVek() + " : " +
              nactenySeznamOsob[i].getPlat() + " : ");
    } // for() END
    // POZOR promenne tridy se ze souboru neobnovuji, obnov nucene
    Osoba.pocetObjektu=pocetUlozenychOsob;
    System.out.println("Pocet osob="+Osoba.pocetObjektu);
    System.out.println("==(2)==== zapis/cteni typu Osoba END ========\n");
    //=(2)======= write/read (pro objekty) END ================================

    //=(3)======= write/read (pro objekty) ====================================
    System.out.println("==(3)==== zapis/cteni typu Osoba  ========");
    // ==> Zalozeni nekolika objektu typu Osoba
    int pocetOsob3=3;
    Osoba[] seznamOsob3=new Osoba[pocetOsob3];
    seznamOsob3[0]=new Osoba("Danek","0123",25,25000);
    seznamOsob3[1]=new Osoba("Vanek","4567",35,35000);
    seznamOsob3[2]=new Osoba("Rokl ", "8901",45,25000);

    // ==> Zalozeni zastupne promenne typu File
    File f3=new File("Osoby3.xxx");
    // ==>Zalozeni a Otevreni souboru pro ZAPIS
    //    Pokud jiz soubor existuje, jeho data se ztrati
    FileOutputStream fos3 = new FileOutputStream(f3);
    ObjectOutputStream oos3 = new ObjectOutputStream(fos3);
    // ==>Zapis do souboru (sekvencni / postupny)
    System.out.println("========= zapis objektu typu osoba =======");
    System.out.println("..........................................");
    for(int i=0;i<pocetOsob3;i++){
      oos3.writeObject(seznamOsob3[i]);
    }// for() END
    // ==>Uzavreni souboru
    oos3.close();

    System.out.println("========= cteni objektu typu Osoba ========");
    // ==>Cteni ze souboru (sekvencni /postupny)
    //    Predpoklad:
    //       - typ objektu v souboru je ZNAMY (zde Osoba)
    //       - pocet objektu v souboru je NEZNAMY
    // ==>Otevreni souboru pro CTENI
    FileInputStream fis3 = new FileInputStream(f3);
    ObjectInputStream ois3 = new ObjectInputStream(fis3);
    // ==>Zalozeni jineho pole Osob
    Osoba[] seznamPrectenychOsob=new Osoba[10];
    int pocetPrectenychOsob=0;
    for(int i=0;i<10;i++){
      if(fis3.available()<=0){// POZOR musi byt fis3, ois3 hlasi ==0 !!!
        pocetPrectenychOsob=i;
        break;
      }// if() END
      seznamPrectenychOsob[i]=(Osoba)ois3.readObject();
    }// for() END
    // ==>Uzavreni souboru pro cteni
    ois3.close();
    // ==>Zruseni souboru (musi byt uzavren)
    if(f3.delete()){
      System.out.println("Soubor: "+f3+" :zrusen");
    }
    // ==>Tisk osob nactenych ze souboru
    for (int i=0;i<pocetPrectenychOsob; i++) {
      if(seznamPrectenychOsob[i] == null){
        continue;
      }// if() END
      System.out.println(seznamPrectenychOsob[i].getJmeno() + " : " +
              seznamPrectenychOsob[i].getTelefon() + " : " +
              seznamPrectenychOsob[i].getVek() + " : " +
              seznamPrectenychOsob[i].getPlat() + " : ");
    }// for() END
    System.out.println("Pocet osob="+pocetPrectenychOsob);
    System.out.println("==(3)==== zapis/cteni typu Osoba END ========\n");
    //=(3)======= write/read (pro objekty) END ================================

  }// main() END

}// X9k class END-------------------------------------------------------------


class Osoba implements Serializable{//-----------------------------------------
  static int pocetObjektu=0;
  String jmeno;
  String telefon;
  int vek;
  int plat=0;

  public Osoba(String jmeno, String telefon, int vek, int plat){
    this.pocetObjektu++;
    this.jmeno=jmeno;
    this.telefon=telefon;
    this.vek=vek;
    this.plat=plat;
  }// Osoba constructor END

  String getJmeno(){
    return(this.jmeno);
  }// getJmeno() END

  String getTelefon(){
    return(this.telefon);
  }// getTelefon() END

  int getVek(){
    return(this.vek);
  }// getVek() END

  int getPlat(){
    return(this.plat);
  }// getPlat() ENd

  void setPlat(int plat){
    this.plat=plat;
  }// setPlat() END

}// Osoba class END------------------------------------------------------------