/*
 * A0B36PRI_091214_12  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 12 - Trideni - zaklady
 *
 * Prihradkove razeni (CaseSort)
 *  Datove struktury - Fronta (Queue, FIFO)
 * 
 */

package a0b36pri_091214_12;

public class X12f {//==========================================================
  
  public static void main(String[] args) {//-----------------------------------
    int[] p = {34,-3,12,56,1234,1,27,-44,6,3,855,-10};// Jen pro kladna int
    //int[] p={   4,  36,  65,   1};
    //int[] p = {0x04,0x24,0x41,0x01};
    System.out.println("===X12f===");
    System.out.println("===Case sort===");
    caseSort(p);
    for(int i = 0; i < p.length; i++){
      System.out.print(p[i]+" ");
    }
    System.out.println("");
    System.out.println("===Case sort END===");
    System.out.println("===X12f END===");
  }// main() END --------------------------------------------------------------
  
  static void caseSort (int[] pole) {//----------------------------------------
    // Jen pro kladne int (2s complement tridi do horni casti pole)
    FrontaCisel[] prihradky = new FrontaCisel[16];// 0-F -> 16 hex cislic
    int j;
    for(int i = 0; i < prihradky.length; i++ ){
      prihradky[i] = new FrontaCisel();
    }
    for(int i = 0; i < 8; i++ ){// int -> 4 byte -> 8 nibble
      for(j = 0; j < pole.length; j++ ){
        prihradky[hexCislice(pole[j],i)].vloz(pole[j]);
      }// for() END
      j = 0;
      for (int k = 0; k < prihradky.length; k++ ){
        while ( ! prihradky[k].jePrazdna() )
          pole[j++] = prihradky[k].odeber();
      }// for() END
    }// for() END
  }// caseSort() END ----------------------------------------------------------
    
   static int hexCislice (int x, int r) {//------------------------------------
     return (x >> 4*r) & 0xF;
   }// hexCislice() END -------------------------------------------------------

}// class X12f END ============================================================

class PrvekFronty {//==========================================================
  PrvekFronty dalsi;
  int hodn;
}// PrvekFronty class END ======================================================

class FrontaCisel {//===========================================================
  private PrvekFronty celo;
  private PrvekFronty volny;
    
  public FrontaCisel() {
    celo = new PrvekFronty();
    volny = celo;
  }
  
  public void vloz(int x) {
    volny.hodn = x;
    volny.dalsi = new PrvekFronty();
    volny = volny.dalsi;
  }
  
  public int odeber() {
    if (jePrazdna())
      throw new RuntimeException( " prazdna fronta" );
    int vysl = celo.hodn;
    celo = celo.dalsi;
    return vysl;
  }
  
  public boolean jePrazdna() {
    return celo == volny;
  }
}// FrontaCisel class END ======================================================
