/*
 * A0B36PRI_091221_13  "PROGRAMOVANI"  01.07.2009
 *   
 * Prednaska 13 - Datove struktury - zaklady
 *
 *  Datove struktury - Zasobnik (Stack, LIFO)
 * 
 */


package a0b36pri_091221_13;
import java.util.*;

public class X13c {//===========================================================
    static {Locale.setDefault (Locale.US);}

    public static void main(String[] args) {
        Scanner read = new Scanner(System.in);
        Osoba o;
        Zasobnik z=new Zasobnik();
        // Naplneni zasobniku
        System.out.println("Naplneni zasobniku");
        z.pushOsoba(new Osoba("Jana","1234"));
        z.pushOsoba(new Osoba("Dana","5678"));
        z.pushOsoba(new Osoba("Honza","8888"));
        o=new Osoba("Karel","2222");
        z.pushOsoba(o);
        System.out.println("Zadej jmeno(enter) a telefon(enter)");
        z.pushOsoba(new Osoba(read.next(),read.next()));
        // Vyprazdneni zasobniku
        System.out.println("Vyprazdneni zasobniku");
        while((o=z.popOsoba()) != null){
            System.out.println(o.getJmeno()+" | "+o.getTelefon());
        }// while() END
  }// main() END
    
}// X13c class END ============================================================
class Osoba {//================================================================
  String jmeno;
  String telefon;
  Osoba dalsi=null;

  public Osoba (String jmeno, String telefon){
    this.jmeno=jmeno;
    this.telefon=telefon;
  }// constructor() END

  void setDalsi (Osoba dalsi){
    this.dalsi=dalsi;
  }// setDalsi() END

  Osoba getDalsi (){
    return(this.dalsi);
  }// getDalsi() END

  String getJmeno(){
    return(this.jmeno);
  }// getJmeno() END

  String getTelefon(){
    return(this.telefon);
  }// getTelefon()
}// Prvek class END ===========================================================


class Zasobnik{//==============================================================
 Osoba vrcholZasobniku;

 public Zasobnik (){
   this.vrcholZasobniku=null;
 }// constructor() END

 void pushOsoba(Osoba osoba){
   if(osoba == null)return; // Prazdna osoba
   if(vrcholZasobniku == null){
     osoba.setDalsi(null);
     vrcholZasobniku=osoba;
   }
   else{
     osoba.setDalsi(vrcholZasobniku);
     vrcholZasobniku=osoba;
   }
 }// pushOsoba() END

 Osoba popOsoba(){
   if(vrcholZasobniku == null)
     return(null);
   else{
     Osoba osoba=vrcholZasobniku;
     vrcholZasobniku=vrcholZasobniku.getDalsi();
     return(osoba);
   }
 }// popOsoba() END

}// Zasobnik class END ========================================================